(load "../Scheme-utilities/exception.scm")

;; Return first expression satisfying PRED 
;; in left-to-right depth-first walk of an sexpression
(define find
  (lambda (pred sexp)
    (find-cont pred 
	       sexp
	       (lambda ()
		 (throw 'find:not-found 'ignore)))))

(define find? 
  (lambda (pred sexp)
    (catch (lambda () 
	     (begin (find pred sexp)
		    #t))
	   (lambda (tag value) 
	     (if (eq? tag 'find:not-found)
		 #f
		 (throw 'find:unexpected-tag tag))))))

(define find-cont
  (lambda (pred sexp fail)
    (cond ((pred sexp) sexp)
	  ((atom? sexp) (fail))
	  (else (find-cont-list pred sexp fail)))))

(define find-cont-list 
  (lambda (pred sexp-list fail)
    (if (null? sexp-list)
	(fail)
	(find-cont pred
		   (car sexp-list)
		   (lambda () 
		     (find-cont-list pred (cdr sexp-list) fail))))))

(define atom?
  (lambda (x) (not (pair? x))))
